%MACRO CUSP2;
%LET D1=0.10;

%MACRO WINCUSP2;

DATA _NULL_;
WINDOW MCUSP2 COLOR=grey
#1 "CONTENT UNIFORMITY ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 2 (GREATER THAN ONE SAMPLE PER LOCATION)" C=yellow
#4  "ENTER DOSAGE FORM(CAPSULE OR TABLET):  " C=blue FORM  $7.
    A=UNDERLINE
#5  "ENTER NUMBER OF LOCATIONS:  " C=blue LOC 4.0 A=UNDERLINE
#6  "ENTER NUMBER PER LOCATION:  " C=blue NUM 4.0 A=UNDERLINE
#8 "ENTER BOUND ON FUTURE PERCENTAGE PASSING (50.0-99.0):  " C=blue LBOUND 4.1
    A=UNDERLINE
#9 "ENTER CONFIDENCE LEVEL (50.0-99.0):  " C=blue CILEVEL 4.1 A=UNDERLINE
#11 "DO YOU WANT TO PRINT THE ACCEPTANCE LIMIT TABLE?" C=blue
#12 "ENTER Y OR N ="  C=blue A1CUSP2 $1.
#14 "DO YOU WANT TO EVALUATE THE ACCEPTANCE LIMIT TABLE?" C=blue
#15 "ENTER Y OR N ="  C=blue A2CUSP2 $1.
#17 "DO YOU WANT THE LOWER BOUND FOR A SPECIFIC SAMPLE RESULT?" C=blue
#18 "ENTER Y OR N ="  C=blue A3CUSP2 $1.;
WINDOW DOSCUSP2 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "DOSAGE FORM MUST BE CAPSULE OR TABLET" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW LOCAT COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS= 10 IROW=5
#1 "NUMBER OF LOCATIONS MUST BE AN INTEGER GREATER THAN 2" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW NUMB COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "SAMPLE SIZE MUST BE AN INTEGER GREATER THAN 1" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW BCUSP2 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "THE LOWER BOUND ON THE PERCENTAGE OF ALL FUTURE BATCHES" C=YELLOW
#2 "PASSING THE USP TEST MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#3 "(TYPICAL VALUES ARE 50.0 AND 95.0)" C=YELLOW
#5 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW CICUSP2 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "CONFIDENCE INTERVAL VALUES MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#2 "(TYPICAL VALUES ARE 90.0, 95.0, OR 99.0)" C=YELLOW
#4 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ANSCUSP2 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "REQUEST REQUIRES A RESPONSE OF: Y OR N" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
FORM='CAPSULE';
LOC=10;
NUM=4;
LBOUND = 95;
CILEVEL = 95;
A1CUSP2 = 'Y';
A2CUSP2 = 'N';
A3CUSP2 = 'N';
MAINCU2:
DISPLAY MCUSP2 BELL;
IF FORM NE 'CAPSULE' AND FORM NE 'TABLET' THEN DO;
DISPLAY DOSCUSP2 BELL;
GOTO MAINCU2;
END;
IF LOC LE 2 OR LOC NE ROUND(LOC) THEN DO;
DISPLAY LOCAT BELL;
GOTO MAINCU2;
END;
IF NUM LE 1 OR NUM NE ROUND(NUM) THEN DO;
DISPLAY NUMB BELL;
GOTO MAINCU2;
END;
IF LBOUND GT 99.0 OR LBOUND LT 50.0 THEN DO;
DISPLAY BCUSP2 BELL;
GOTO MAINCU2;
END;
IF CILEVEL GT 99.0 OR CILEVEL LT 50.0 THEN DO;
DISPLAY CICUSP2 BELL;
GOTO MAINCU2;
END;
IF A1CUSP2 NE 'Y' AND A1CUSP2 NE 'N' AND
   A1CUSP2 NE 'y' AND A1CUSP2 NE 'n' THEN DO;
DISPLAY ANSCUSP2 BELL;
GOTO MAINCU2;
END;
IF A2CUSP2 NE 'Y' AND A2CUSP2 NE 'N' AND
   A2CUSP2 NE 'y' AND A2CUSP2 NE 'n' THEN DO;
DISPLAY ANSCUSP2 BELL;
GOTO MAINCU2;
END;
IF A3CUSP2 NE 'Y' AND A3CUSP2 NE 'N' AND
   A3CUSP2 NE 'y' AND A3CUSP2 NE 'n' THEN DO;
DISPLAY ANSCUSP2 BELL;
GOTO MAINCU2;
END;
CALL SYMPUT("A1CUSP2",PUT(UPCASE(A1CUSP2),$1.));
CALL SYMPUT("A2CUSP2",PUT(UPCASE(A2CUSP2),$1.));
CALL SYMPUT("A3CUSP2",PUT(UPCASE(A3CUSP2),$1.));
CALL SYMPUT("LOC",PUT(LOC,4.0));
CALL SYMPUT("NUM",PUT(NUM,4.0));
CALL SYMPUT("LBOUND",PUT(LBOUND,4.1));
CALL SYMPUT("FORM",PUT(UPCASE(FORM),$7.));
CALL SYMPUT("CILEVEL",PUT(CILEVEL,4.1)); STOP;
RUN;

%MEND WINCUSP2;

OPTIONS NODATE NONUMBER;

%macro cullu;
   LLU = MEAN - Z * SQRT(MVAR / N);
   C2 = 0.078;
   K = 1 + 30 * LLU * LLU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 30 * LLU * LLU / (SIGMA * SIGMA));
   PCV2 = 1 - PROBF(30 / (K * C2 * C2), V, 29, 0.0);
   P1L = PROBNORM((100 - LLU) / SIGMA)
         - PROBNORM((85 - LLU) / SIGMA);
   P1U = PROBNORM((115 - LLU) / SIGMA)
         - PROBNORM((100 - LLU) / SIGMA);
   P1 = P1L + P1U;
   P2L = PROBNORM((85 - LLU) / SIGMA)
         - PROBNORM((75 - LLU) / SIGMA);
   P2U = PROBNORM((125 - LLU) / SIGMA)
         - PROBNORM((115 - LLU) / SIGMA);
   P2 = P2L + P2U;
  IF TYPE = 'T' THEN
   PCTTAB2 = P1 ** 30 + 30 * P1 **29 *P2;
  ELSE IF TYPE = 'C' THEN
   PCTTAB2 = P1 ** 27 * (P1*P1*P1 + 30*P1*P1*P2 + 435*P1*P2*P2
            + 4060*P2*P2*P2);
   TPROBL2 = MAX(PCV2 + PCTTAB2 - 1, 0);
  C1 = 0.060;
  K = 1 + 10 * LLU * LLU / (SIGMA * SIGMA);
  V = K * K / (1 + 2 * 10 * LLU * LLU / (SIGMA * SIGMA));
  PCV1 = 1 - PROBF(10 / (K * C1 * C1), V, 9, 0.0);
  IF TYPE = 'T' THEN
  PCTTAB1 = P1**10;
  ELSE IF TYPE = 'C' THEN
  PCTTAB1 = P1**9 * (P1 + 10*P2);
  LPROB1 = MAX(PCV1 + PCTTAB1 - 1, 0);
  OVERBDL = MAX(TPROBL2, LPROB1);
%mend cullu;
%macro cuulu;
   ULU = MEAN + Z * SQRT(MVAR / N);
   C2 = 0.078;
   K = 1 + 30 * ULU * ULU / (SIGMA * SIGMA);
   V = K * K / (1 + 2 * 30 * ULU * ULU / (SIGMA * SIGMA));
   PCV2 = 1 - PROBF(30 / (K * C2 * C2), V, 29, 0.0);
   P1L = PROBNORM((100 - ULU) / SIGMA)
         - PROBNORM((85 - ULU) / SIGMA);
   P1U = PROBNORM((115 - ULU) / SIGMA)
         - PROBNORM((100 - ULU) / SIGMA);
   P1 = P1L + P1U;
   P2L = PROBNORM((85 - ULU) / SIGMA)
         - PROBNORM((75 - ULU) / SIGMA);
   P2U = PROBNORM((125 - ULU) / SIGMA)
         - PROBNORM((115 - ULU) / SIGMA);
   P2 = P2L + P2U;
  IF TYPE = 'T' THEN
   PCTTAB2 = P1 ** 30 + 30 * P1 **29 *P2;
  ELSE IF TYPE = 'C' THEN
   PCTTAB2 = P1 ** 27 * (P1*P1*P1 + 30*P1*P1*P2 + 435*P1*P2*P2
            + 4060*P2*P2*P2);
   TPROBL2 = MAX(PCV2 + PCTTAB2 - 1, 0);
  C1 = 0.060;
  K = 1 + 10 * ULU * ULU / (SIGMA * SIGMA);
  V = K * K / (1 + 2 * 10 * ULU * ULU / (SIGMA * SIGMA));
  PCV1 = 1 - PROBF(10 / (K * C1 * C1), V, 9, 0.0);
  IF TYPE = 'T' THEN
  PCTTAB1 = P1**10;
  ELSE IF TYPE = 'C' THEN
  PCTTAB1 = P1**9 * (P1 + 10*P2);
  LPROB1 = MAX(PCV1 + PCTTAB1 - 1, 0);
  OVERBDU = MAX(TPROBL2, LPROB1);
%mend cuulu;

%MACRO CALCUSP2;
DATA TABC;
 LENGTH TYPE $ 1;
   D=&D1;
   TYPE = "&FORM";
   Z = PROBIT((1 + SQRT(&CILEVEL/100))/2);
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   CALL SYMPUT("TOT",PUT(N, 5.0));
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SEBOUND = 9.2;
   SMLIM = 9.2;
   NEXTL = 84.9;
   NEXTU = 115.1;
  DO SE = D TO SEBOUND BY D;
   MEANL = NEXTL;
   MEANU = NEXTU;
   SMBOUND = SMLIM;
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
  DO SM = D TO SMBOUND BY D;
   IF MEANL = . THEN GOTO OVER;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   DO MEAN = MEANL - D TO 115.5 BY D;
%cullu
   IF OVERBDL > &LBOUND/100 THEN DO;
      MEANL = MEAN;
      GOTO UPPER;
   END;
 END;
    MEANL = .;
    MEANU = .;
    IF SE=D THEN DO;
     SMLIM = SM - D;
     OUTPUT;
     SM=10;
     GOTO OVER;
                 END;
    IF SM=D THEN DO; SE = 10; GOTO OVER; END;
    GOTO SKIP;
 UPPER:

 DO MEAN = MEANU + D TO 84.9 BY -D;
%cuulu
   IF OVERBDU > &LBOUND/100 THEN DO;
      MEANU = MEAN;
      GOTO OUT;
   END;
 END;
 OUT:
 IF MEANU <= MEANL OR MEAN <= MEANL THEN DO;
    MEANL = .;
    MEANU = .;
    IF SE=D THEN DO;
     SMLIM = SM - D;
     OUTPUT;
     SM=10;
     GOTO OVER;
     END;
    IF SM=D THEN DO; SE = 10; GOTO OVER; END;
 END;

 SKIP: OUTPUT;
    IF SM = D THEN DO;
      NEXTL = MEANL;
      NEXTU = MEANU;
       END;
 OVER:
   END;
  END;
 KEEP N NN L D MEAN SE SM MEANL MEANU OVERBDL OVERBDU;
data tabc;
  set tabc;
  if SE = 10 or SM = 10 then delete;
PROC SORT DATA=TABC; BY SE SM;

%MEND CALCUSP2;

%MACRO PRTCUSP2;
options ls=132;
PROC TRANSPOSE DATA = TABC OUT = LDAT PREFIX = L;
   VAR MEANL;
   BY SE;

PROC TRANSPOSE DATA = TABC OUT = UDAT PREFIX = U;
   VAR MEANU;
   BY SE;

DATA together;
   MERGE LDAT UDAT;
   BY SE;
proc sort data=together; by se;
data miss;
  l1=.; u1=.;
  l2=.; u2=.;
  l3=.; u3=.;
  l4=.; u4=.;
  l5=.; u5=.;
  l6=.; u6=.;
  l7=.; u7=.;
  l8=.; u8=.;
  l9=.; u9=.;
  l10=.; u10=.;
  l11=.; u11=.;
  l12=.; u12=.;
  l13=.; u13=.;
  l14=.; u14=.;
  l15=.; u15=.;
  l16=.; u16=.;
  l17=.; u17=.;
  l18=.; u18=.;
  l19=.; u19=.;
  l20=.; u20=.;
  l21=.; u21=.;
  l22=.; u22=.;
  l23=.; u23=.;
  l24=.; u24=.;
  l25=.; u25=.;
  l26=.; u26=.;
  l27=.; u27=.;
  l28=.; u28=.;
  l29=.; u29=.;
  l30=.; u30=.;
  l31=.; u31=.;
  l32=.; u32=.;
  l33=.; u33=.;
  l34=.; u34=.;
  l35=.; u35=.;
  l36=.; u36=.;
  l37=.; u37=.;
  l38=.; u38=.;
  l39=.; u39=.;
  l40=.; u40=.;
  l41=.; u41=.;
  l42=.; u42=.;
  l43=.; u43=.;
  l44=.; u44=.;
  l45=.; u45=.;
  l46=.; u46=.;
  l47=.; u47=.;
  l48=.; u48=.;
  l49=.; u49=.;
  l50=.; u50=.;
  l51=.; u51=.;
  l52=.; u52=.;
  l53=.; u53=.;
  l54=.; u54=.;
  l55=.; u55=.;
  l56=.; u56=.;
  l57=.; u57=.;
  l58=.; u58=.;
  l59=.; u59=.;
  l60=.; u60=.;
  l61=.; u61=.;
  l62=.; u62=.;
  l63=.; u63=.;
  l64=.; u64=.;
  l65=.; u65=.;
  l66=.; u66=.;
  l67=.; u67=.;
  l68=.; u68=.;
  l69=.; u69=.;
  l70=.; u70=.;
  l71=.; u71=.;
  l72=.; u72=.;
data all;
   merge miss together;
DATA _NULL_;
   SET ALL;
   IF L1 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L1 U1 L2 U2 L3 U3 L4 U4 L5 U5 L6 U6 L7 U7 L8 U8 L9 U9)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '0.1' +10 '0.2' +10 '0.3' +10 '0.4' +10 '0.5' +10
              '0.6' +10 '0.7' +10 '0.8' +10 '0.9' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
TITLE1 "ACCEPTANCE LIMITS FOR &FORM CONTENT UNIFORMITY";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "LOWER BOUND = &LBOUND, CONFIDENCE LEVEL = &CILEVEL";
TITLE4 'TABLE ENTRIES ARE LOWER(LL) AND UPPER(UL) LIMITS ON THE MEAN';
TITLE5 "OF &TOT ASSAYS-&NUM ASSAYS AT EACH OF &LOC DIFFERENT LOCATIONS";
TITLE6 'SE IS THE POOLED WITHIN LOCATION STANDARD DEVIATION';
TITLE7 'STANDARD DEVIATIONS AND MEANS ARE EXPRESSED IN % CLAIM';
TITLE9 'STANDARD DEVIATION OF LOCATION MEANS';

DATA _NULL_;
   SET ALL;
   IF L10 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L10 U10 L11 U11 L12 U12 L13 U13 L14 U14
      L15 U15 L16 U16 L17 U17 L18 U18)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '1.0' +10 '1.1' +10 '1.2' +10 '1.3' +10 '1.4' +10
              '1.5' +10 '1.6' +10 '1.7' +10 '1.8' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L19 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L19 U19 L20 U20 L21 U21 L22 U22 L23 U23
      L24 U24 L25 U25 L26 U26 L27 U27)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '1.9' +10 '2.0' +10 '2.1' +10 '2.2' +10 '2.3' +10
              '2.4' +10 '2.5' +10 '2.6' +10 '2.7' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L28 = . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L28 U28 L29 U29 L30 U30 L31 U31 L32 U32
      L33 U33 L34 U34 L35 U35 L36 U36)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '2.8' +10 '2.9' +10 '3.0' +10 '3.1' +10 '3.2' +10
              '3.3' +10 '3.4' +10 '3.5' +10 '3.6' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L37 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L37 U37 L38 U38 L39 U39 L40 U40 L41 U41
      L42 U42 L43 U43 L44 U44 L45 U45)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '3.7' +10 '3.8' +10 '3.9' +10 '4.0' +10 '4.1' +10
              '4.2' +10 '4.3' +10 '4.4' +10 '4.5' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L46 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L46 U46 L47 U47 L48 U48 L49 U49 L50 U50
      L51 U51 L52 U52 L53 U53 L54 U54)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '4.6' +10 '4.7' +10 '4.8' +10 '4.9' +10 '5.0' +10
              '5.1' +10 '5.2' +10 '5.3' +10 '5.4' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L55 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L55 U55 L56 U56 L57 U57 L58 U58 L59 U59
      L60 U60 L61 U61 L62 U62 L63 U63)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '5.5' +10 '5.6' +10 '5.7' +10 '5.8' +10 '5.9' +10
              '6.0' +10 '6.1' +10 '6.2' +10 '6.3' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L64 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L64 U64 L65 U65 L66 U66 L67 U67 L68 U68
      L69 U69 L70 U70 L71 U71 L72 U72)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '6.4' +10 '6.5' +10 '6.6' +10 '6.7' +10 '6.8' +10
              '6.9' +10 '7.0' +10 '7.1' +10 '7.2' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;

run;
%MEND PRTCUSP2;


%MACRO EVCUSP2;

DATA _NULL_; WINDOW SMAIN COLOR=GREY
#1 "TO EVALUATE LIMITS, THE USER MUST SPECIFY THE RANGE OF" C=yellow
#2 "POSSIBLE POPULATION VALUES FOR THE MEAN, WITHIN LOCATION" C=yellow
#3 "STD DEV AND BETWEEN LOCATION STD DEV" C=yellow
#5 "ENTER ALL VALUES AS POSITIVE INTEGERS" C=yellow
#7  "ENTER LOWER BOUND FOR MEAN:            " C=blue ULOW 4.0
    A=UNDERLINE
#8  "ENTER UPPER BOUND FOR MEAN:            " C=blue UHIGH 4.0
    A=UNDERLINE
#9  "ENTER INCREMENT FOR MEAN:              " C=blue UINCRE 4.0
    A=UNDERLINE
#10 "ENTER DIVISOR FOR MEAN:                " C=blue UDIV 4.0
    A=UNDERLINE
#12 "ENTER LOWER BOUND FOR WITHIN STD DEV:  " C=blue SELOW 4.0
    A=UNDERLINE
#13 "ENTER UPPER BOUND FOR WITHIN STD DEV:  " C=blue SEHIGH 4.0
    A=UNDERLINE
#14 "ENTER INCREMENT FOR WITHIN STD DEV:    " C=blue SEINCRE 4.0
    A=UNDERLINE
#15 "ENTER DIVISOR FOR WITHIN STD DEV:      " C=blue SEDIV 4.0
    A=UNDERLINE
#17 "ENTER LOWER BOUND FOR BETWEEN STD DEV: " C=blue SMLOW 4.0
    A=UNDERLINE
#18 "ENTER UPPER BOUND FOR BETWEEN STD DEV: " C=blue SMHIGH 4.0
    A=UNDERLINE
#19 "ENTER INCREMENT FOR BETWEEN STD DEV:   " C=blue SMINCRE 4.0
    A=UNDERLINE
#20 "ENTER DIVISOR FOR BETWEEN STD DEV:     " C=blue SMDIV 4.0
    A=UNDERLINE;
WINDOW PINT COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST BE POSITIVE INTEGERS" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ORD  COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ERROR: UPPER BOUND IS LESS THAN LOWER BOUND" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
ULOW=950;
UHIGH=1000;
UINCRE=50;
UDIV=10;
SELOW=22;
SEHIGH=22;
SEINCRE=10;
SEDIV=10;
SMLOW=22;
SMHIGH=22;
SMINCRE=10;
SMDIV=10;
SMAIN:
DISPLAY SMAIN BELL;
IF ULOW LT 1 OR ROUND(ULOW) NE ULOW
OR UHIGH LT 1 OR ROUND(UHIGH) NE UHIGH
OR UINCRE LT 1 OR ROUND(UINCRE) NE UINCRE
OR UDIV LT 1 OR ROUND(UDIV) NE UDIV
OR SELOW LT 1 OR ROUND(SELOW) NE SELOW
OR SEHIGH LT 1 OR ROUND(SEHIGH) NE SEHIGH
OR SEINCRE LT 1 OR ROUND(SEINCRE) NE SEINCRE
OR SEDIV LT 1 OR ROUND(SEDIV) NE SEDIV
OR SMLOW LT 1 OR ROUND(SMLOW) NE SMLOW
OR SMHIGH LT 1 OR ROUND(SMHIGH) NE SMHIGH
OR SMINCRE LT 1 OR ROUND(SMINCRE) NE SMINCRE
OR SMDIV LT 1 OR ROUND(SMDIV) NE SMDIV
THEN DO;
DISPLAY PINT;
GOTO SMAIN;
END;
IF ULOW GT UHIGH
OR SELOW GT SEHIGH
OR SMLOW GT SMHIGH
THEN DO;
DISPLAY ORD;
GOTO SMAIN;
END;
CALL SYMPUT("ULOW",PUT(ULOW,4.0));
CALL SYMPUT("UHIGH",PUT(UHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(UINCRE,4.0));
CALL SYMPUT("UDIV",PUT(UDIV,4.0));
CALL SYMPUT("SELOW",PUT(SELOW,4.0));
CALL SYMPUT("SEHIGH",PUT(SEHIGH,4.0));
CALL SYMPUT("SEINCRE",PUT(SEINCRE,4.0));
CALL SYMPUT("SEDIV",PUT(SEDIV,4.0));
CALL SYMPUT("SMLOW",PUT(SMLOW,4.0));
CALL SYMPUT("SMHIGH",PUT(SMHIGH,4.0));
CALL SYMPUT("SMINCRE",PUT(SMINCRE,4.0));
CALL SYMPUT("SMDIV",PUT(SMDIV,4.0)); STOP;
RUN;


%MACRO SIGCUSP2;
%calcusp2
   %DO U = &ULOW %TO &UHIGH %BY &UINCRE;
      %DO SIGSE = &SELOW %TO &SEHIGH %BY &SEINCRE;
         %DO SIGSM = &SMLOW %TO &SMHIGH %BY &SMINCRE;

  DATA SAVE2;
    SET TABC END = LAST;
   U = &U / &UDIV;
   D = &D1;
   SIGSE = &SIGSE / &SEDIV;
   SIGSM = &SIGSM / &SMDIV;
   SIGSM2 = SIGSM * SIGSM;
   EXPSE2 = SIGSE * SIGSE;
   EXPSM2 = EXPSE2 + NN * SIGSM * SIGSM;
   PMEAN = PROBNORM((MEANU - U) * SQRT((N) / EXPSM2))
           - PROBNORM((MEANL - U) * SQRT((N) / EXPSM2));
   PSE = PROBCHI(L * (NN - 1) * SE * SE / EXPSE2, L * (NN -1))
         - PROBCHI(L * (NN - 1) * (SE - D) * (SE - D) /
         EXPSE2, L * (NN - 1));
   PSM = PROBCHI((L - 1) * NN * SM * SM / EXPSM2, L - 1)
         - PROBCHI((L - 1) * NN * (SM - D) * (SM - D) /
         EXPSM2, L - 1);
   P = PMEAN * PSE * PSM;
   PSUM + P;
   IF LAST THEN OUTPUT;
   RUN;
   PROC APPEND BASE = SAVES2E DATA = SAVE2;
   RUN;

       %END;
      %END;
     %END;

%MEND SIGCUSP2;

%SIGCUSP2

PROC PRINT DATA = SAVES2E split = '*';
  label U = 'MEAN'
       SIGSE = 'WITHIN LOCATION*STD DEV'
       SIGSM = 'BETWEEN LOCATION* STD DEV'
       PSUM = 'PROBABILITY*OF*PASSING';
   VAR U SIGSE SIGSM PSUM;
TITLE1 "ACCEPTANCE LIMITS FOR &FORM CONTENT UNIFORMITY";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE";
TITLE4 "WITH &NUM ASSAYS AT EACH OF &LOC LOCATIONS";
TITLE5 "CONFIDENCE LEVEL = &CILEVEL & LOWER BOUND = &LBOUND";
RUN;
%MEND EVCUSP2;

%MACRO SMPCUSP2;

DATA _NULL_; WINDOW TMAIN COLOR=GREY
#3 "TO DETERMINE LOWER BOUND FOR FOUND SAMPLE RESULTS" C=yellow
#7  "ENTER SAMPLE MEAN (% CLAIM):            " C=blue MEAN 6.3 A=UNDERLINE
#9  "ENTER SAMPLE WITHIN STD DEV (% CLAIM):  " C=blue SE 6.3 A=UNDERLINE
#11 "ENTER SAMPLE BETWEEN STD DEV (% CLAIM): " C=blue SM 6.3 A=UNDERLINE
#12 "(I.E. STANDARD DEVIATION OF SAMPLE LOCATION MEANS)" C=blue;
WINDOW LTZ COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST BE NON NEGATIVE" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW RANGE COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "MEAN MUST BE BETWEEN 85.1 AND 114.9" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
MEAN=100.00;
SE=2.20;
SM=2.46;
TMAIN:
DISPLAY TMAIN BELL;
IF SE LE 0 OR SM LE 0
THEN DO;
DISPLAY LTZ;
GOTO TMAIN;
END;
IF MEAN LT 85.1 OR MEAN GT 114.9
THEN DO;
DISPLAY RANGE;
GOTO TMAIN;
END;
CALL SYMPUT("MEAN",PUT(MEAN,6.3));
CALL SYMPUT("SE",PUT(SE,6.3));
CALL SYMPUT("SM",PUT(SM,6.3)); STOP;
RUN;

DATA TAB;
 LENGTH TYPE $ 1;
   TYPE = "&FORM";
   Z = PROBIT((1 + SQRT(&CILEVEL/100))/2);
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   SE = &SE;
   SM = &SM;
   MEAN = &MEAN;
   CILEVEL = &CILEVEL;
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
%cullu
%cuulu
  OVERBD = MIN(OVERBDU, OVERBDL);
 KEEP SE MEAN SM OVERBD;
PROC PRINT SPLIT='*';
 LABEL   SE = 'SAMPLE*WITHIN LOCATION*STD DEV'
         MEAN = 'SAMPLE*MEAN'
         SM = 'SAMPLE*BETWEEN LOCATION*STD DEV'
         OVERBD = 'LOWER BOUND';
  ID MEAN;
  VAR SE SM OVERBD;
TITLE1 "ACCEPTANCE LIMITS FOR &FORM CONTENT UNIFORMITY";
TITLE2 "SAMPLING PLAN 2 (&LOC LOCATIONS, &NUM PER LOCATION)";
TITLE3 "PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST";
TITLE4 "WITH &CILEVEL.% ASSURANCE";
TITLE5 'FOR GIVEN SAMPLE MEAN, WITHIN AND BETWEEN LOCATION STD DEV';
RUN;
%MEND SMPCUSP2;

%MACRO ANACUSP2;
    %WINcusp2;
%IF %UPCASE(&A1CUSP2)=Y %THEN %DO;
     %CALCUSP2;
     %PRTCUSP2;
    %END;
%IF %UPCASE(&A2CUSP2)=Y %THEN %DO;
      %EVCUSP2;
PROC DATASETS LIBRARY=WORK;
   DELETE SAVES2E;
    %END;
%IF %UPCASE(&A3CUSP2)=Y %THEN %DO;
     %SMPCUSP2;
    %END;
%MEND ANACUSP2;

%ANACUSP2

RUN;
%MEND CUSP2;
%CUSP2
